PROGRAM CONVSKEL;   {Created on Sept. 04th, 2008. }

USES Crt, Dos, Chasware;

     {$I BONESVAR.INC}   {v1.00 released as of 10/09/2008.}

     {INC file statement added 09/08/08}
{ ======================================================== }

CONST Compile_Date: STRING = 'October 09, 2008.';

      Release_Date: STRING = 'October 09th, 2008.';  {10/08/08}

      VersionC: STRING = 'v1.00';
           {09/21/08: v0.45 beta. 10/08/08: v1.00; official release}
   { ======================================================== }

TYPE BONES076_PLAYER = RECORD   {SKELPLAY.DAT layout. Revised 01-15-2007}
       RealName    : STRING[50];    { player's real name. used for verification }
       LordName    : STRING[20];    { Player's LORD Name. }
       PlayNum     : BYTE;          { Player's record number. Req'd by LIST_CUSTOMERS }
       Visits      : BYTE;          { # of Visits to IGM today }
       HitMax      : INTEGER;       { Max Hitpoints}
       Strength    : INTEGER;       { Strength points}
       Defense     : INTEGER;       { Defense points }
       Charm       : INTEGER;       { Charm points}
       Forest      : INTEGER;       { Forest Fights }
       Gems        : INTEGER;       { Gems gained/lost }
       Gold        : LONGINT;       { Gold Coins }
       Wisdom      : LONGINT;       { Experience Points gain/loss "Wisdom" }
       Gems_Int    : LONGINT;       { 01/15/07: Gems Interest rec'd today }
       Gold_Int    : LONGINT;       { 01/15/07: Gold Interest rec'd today }
       { ----------------------------- }
       Gems_Deposits  : LONGINT;    { 01/15/07: Gems Deposited today. }
       Gems_Withdrawn : LONGINT;    { 01/15/07: Gems Withdrawn today. }
       Gold_Deposits  : LONGINT;    { 01/15/07: Gold Deposited today. }
       Gold_WithDrawn : LONGINT;    { 01/15/07: Gold Withdrawn today. }
             {Note: these 4 vars were never put into use by L.S. igm}
       { ----------------------------- }
       GemsBank    : LONGINT;       { 01/15/07: Gems in IGM Bank. }
       GoldBank    : LONGINT;       { 01/15/07: Gold in IGM Bank. }
     END;  {RECORD}

  { 10/08/08: Renamed OldBones_Player to Bones076_Player. }
  { =================================================================== }


{ Moved BONES076_PLAYER and Skeleton_Player structures into }
{ the BONESVAR.INC file 09/08/08 3:20 am. }

CONST chr254 = chr(254);
	 { ======================================================== }

VAR Old_Data_File, New_Customers_File: FILE;

    Old_Rec : BONES076_PLAYER;       {09/04/08}
    New_Rec : SKELETON_PLAYER;       {09/04/08}

    Records_Count: BYTE;  {09/04/08: Total records processed.}
    Skip_Count: BYTE;     {09/04/08: Total Skipped records.}
    Valid_Count: BYTE;    {09/04/08: Total Records Converted.}

    Bones_Path  : STRING[128];

    OldFile_FN : STRING;  { Path/filename for BONES076.DAT.}

    SkelPlay_FN : STRING;  { Path/filename for new SKELPLAY.DAT File.}

    Skip_Record: BOOLEAN;  { Skip writing current record to database? }
    { ======================================================== }


PROCEDURE LOCAL_PAUSE;
  VAR MKey: CHAR;
BEGIN;                     { For Local mode screen usage only. }
  WriteLn('     <PAUSE> ');
  MKey:= ReadKey;          { Readkey: not usable remotely. }
END;   { LOCAL_PAUSE ===================================================== }


BEGIN
  clrscr;

  Records_Count:= 0;  { Initialize Total Records Processed Counter}
  Valid_Count:= 0;    { Initialize Total Records Converted Counter}
  Skip_Count:= 0;     { Initialize Total Skipped Records Counter.}

  WriteLn(' ');
  WriteLn(chr254 + '  Running L.S. v0.76 to v0.78 Beta Player Database Conversion Utility.');  {09/04/08}

  WriteLn(' ');

  WriteLn(chr254 + '  CONVSKEL.EXE '+VersionC+':  Compile Date:  '+Compile_Date);

  WriteLn(chr254 + '  '+VersionC+' Officially released on '+Release_Date);
     {10/08/08: added statement from CONVLORE.PAS file.}

  WriteLn(' ');
  WriteLn(chr254 + '  CONVSKEL.EXE reads your BONES076.DAT file, and converts its ');
  WriteLn(chr254 + '  records to use L.S. v0.78 Beta''s player database format.  It ');
  WriteLn(chr254 + '  writes them to the IGM''s new database file SKELPLAY.DAT. ');

  WriteLn(chr254 + '  Deleted records are NOT written to the new file.'); {added 01/31/07}

  WriteLn(' ');
  WriteLn(chr254 + '  Searching now for an BONES076.DAT File to process.');

  Bones_Path:= Copy(ParamStr(0),1,Length(ParamStr(0))-12);
      { Subtracts 12 to delete the "CONVSKEL.EXE" part. }

  OldFile_FN:= Bones_Path+'BONES076.DAT';   {09/04/08}

  SkelPlay_FN:= Bones_Path+'SKELPLAY.DAT';   {09/04/08}

  WriteLn(chr254 + '    Looking in directory: '+Bones_Path);         {09/04/08}
  WriteLn(chr254 + '    Searching for file:   '+OldFile_FN);       {09/04/08}
  WriteLn(' ');

  IF NOT Exist(OldFile_FN) THEN  {Can not find the BONES076.DAT File}
    BEGIN
      WriteLn(chr254 + '  ERROR:  Could Not Find the LORD Skeleton Database File ...');
      WriteLn(chr254 + '  The file BONES076.DAT is missing from this directory.');
      WriteLn(' ');

      WriteLn(chr254 + '  To use CONVSKEL to convert your current SKELPLAY.DAT file ');
      WriteLn(chr254 + '  to use the new database structure, needed by L.S. v0.78+ ');    {09/04/08}
      WriteLn(chr254 + '  betas, rename your current database file to BONES076.DAT. ');
      WriteLn(chr254 + '  Then re-run CONVSKEL again. ');

      WriteLn(' ');
      WriteLn(chr254 + '  WARNING: ** This WILL OVER-WRITE any existing SKELPLAY.DAT file!! **'); {09/04/08}
      WriteLn(chr254 + '  Use SKELEDIT.EXE v1.00 to verify all new records.  ');

      WriteLn(' ');

      HALT(1);
    END;

  WriteLn(chr254 + '  Located BONES076.DAT File. Processing database records now.');  {09/04/08}
  WriteLn(chr254 + '    Creating file:  '+SkelPlay_FN);
  WriteLn(' ');

  LOCAL_PAUSE;   {09/04/08}

  WriteLn(chr254 + '  CONVSKEL.EXE will pause screen after displaying each batch of ');
  WriteLn(chr254 + '  20 records, so user can monitor the records processed. Records ');  {09/04/08}
  WriteLn(chr254 + '  with no valid LORD Character AND Real Names are NOT converted.');   {09/04/08}

  WriteLn(' ');            {09/04/08}
  WriteLn(chr254 + '    Four seconds delay for time to read above text.');  {11/18/06}

  WriteLn(' ');
  DELAY(4000);

  FileMode:= 64;

  ASSIGN(Old_Data_File,'BONES076.DAT');
  RESET(Old_Data_File,SizeOf(Old_Rec));

  ASSIGN(New_Customers_File,'SKELPLAY.DAT');
  REWRITE(New_Customers_File,SizeOf(New_Rec));

  WHILE NOT EOF (Old_Data_File) DO
    BEGIN
      BlockRead(Old_Data_File,Old_Rec,1);

      WITH Old_Rec DO
        BEGIN
          INC(Records_Count);     { Total Records processed counter}

          WriteLn(chr254 + '   Processing old record of '+LordName+'.  Record #', Records_Count);

          New_Rec.RealName  := RealName;
          New_Rec.LordName  := LordName;
          New_Rec.PlayNum   := PlayNum;
          New_Rec.Visits    := Visits;

          New_Rec.Adoptions   := 0;          {09/13/08 relocation}
          New_Rec.Enemy_Kills := 0;          {Added 09/13/08}
          New_Rec.IGM_Fights  := 250;        {09/13/08 relocation}
          New_Rec.Pellets     := 0;          {09/13/08 relocation}

          New_Rec.Skills      := 0;          {09/13/08 relocation/rename}
          New_Rec.HitMax      := HitMax;
          New_Rec.Strength    := Strength;
          New_Rec.Defense     := Defense;

          New_Rec.Charm       := Charm;
          New_Rec.Gems        := Gems;
          New_Rec.Potions     := 0;          {Added 09/04/08}
          New_Rec.Gems_Int    := Gems_Int;

          New_Rec.Gold_Int    := Gold_Int;
          New_Rec.GemsBank    := GemsBank;
          New_Rec.GoldBank    := GoldBank;
          New_Rec.Gold        := 0;          {09/13/08 relocation}

          New_Rec.Wisdom        := 0;        {09/13/08 relocation}
          New_Rec.Camp_Attack   := FALSE;    {Added 09/13/08}
          New_Rec.Camp_Dead     := FALSE;    {Added 09/13/08}
          New_Rec.Fairy_Rescue  := FALSE;    {Added 09/13/08}

          New_Rec.Fought_OldMan := FALSE;    {Added 09/13/08}
          New_Rec.Paid_GemsInt  := FALSE;    {Added 09/04/08}
          New_Rec.Paid_GoldInt  := FALSE;    {Added 09/04/08}
          New_Rec.Sleeping      := FALSE;    {Added 09/04/08}

          New_Rec.Was_Killed    := FALSE;    {09/13/08 rename/relocation}
          New_Rec.Who_Attack    := ' ';      {Added 09/13/08}
          New_Rec.Next_Time     := 0;        {09/13/08 relocation}

        END;  {With Old_Rec - ending}

          { FOREST var replaced by Adoptions. 09/04/08 }
          { Gems_Deposits var replaced by Pellets. 09/04/08 }
          { Gems_Withdrawn var replaced by Potions. 09/04/08 }
          { Gold_Deposits var replaced by Skill_Pts. 09/04/08 }
          { Gold_Withdrawn var replaced by Paid_GemsInt. 09/04/08 }

          { Paid_GemsInt, Paid_GoldInt, & Sleeping added. 09/04/08 }
          { IGM_Fights, Dead added. 09/08/08 }
          { Next_Time added 09/09/08 }


      { =========== Remove DELETED RECORDS from file ========= }
      IF (S2U(Old_Rec.RealName) = 'X')
         AND (S2U(Old_Rec.LordName) = 'X') THEN
        BEGIN
          Skip_Record:= TRUE;

          INC(Skip_Count);
        END
      ELSE
        BEGIN
          Skip_Record:= FALSE;

          INC(Valid_Count);

          WriteLn(chr254 + ' Retained record for player:  '+New_Rec.LordName);  {09/04/08}

          WriteLn(chr254 + ' GemsBank: '+COMMA(New_Rec.GemsBank)+'.  GoldBank:  '+COMMA(New_Rec.GoldBank));
             {09/04/08: non-debug}

             { 09/21/08: Deleted debug lines listing PlayNum, }
             { Visits, Realname and LordName values. }

          DELAY(2000);  {09/21/08: dropped to 2 sec from 3 sec}
        END;

      IF NOT Skip_Record THEN
        BlockWrite(New_Customers_File,New_Rec,1);

           {  Pause screen after each 20 records }
      IF Records_Count = 20 THEN Local_Pause;
      IF Records_Count = 40 THEN Local_Pause;
      IF Records_Count = 60 THEN Local_Pause;
      IF Records_Count = 80 THEN Local_Pause;
      IF Records_Count = 100 THEN Local_Pause;
      IF Records_Count = 120 THEN Local_Pause;
      IF Records_Count = 140 THEN Local_Pause;
    END;  {WITH - ending}

  CLOSE(Old_Data_File);
  CLOSE(New_Customers_File);

  WriteLn(' ');
  WriteLn(chr254 + '  FINISHED:  Processed ',Records_Count,' old database records.');
  Writeln(' ');

  IF Skip_Count > 0 THEN    {Show only if records were skipped}
    BEGIN
      WriteLn(chr254 + '  NOTES:  Skipped writing ',Skip_Count,' database records which ');
      WriteLn(chr254 + '          do not belong to valid users of the IGM.');
      WriteLn(' ');
    END;

  WriteLn(chr254 + '  SUMMARY: Converted ',Valid_Count,' old database records from BONES076.DAT ');  {09/04/08}
  WriteLn(chr254 + '           file, and wrote them to the new SKELPLAY.DAT file.');  {09/04/08}
  WriteLN(' ');

  WriteLn(chr254 + '  CONVSKEL.EXE '+VersionC+': Copyright 2008 by Donald Tidmore.');
  WriteLn(' ');

  HALT(0);
END.  {Ending of CONVSKEL.PAS program }


{ v0.10: Adapted CONVOUTS.PAS to create CONVSKEL.EXE code file. }
{ Finished initial coding session at 1:31 am 09/04/2008. }
{ First compilation done successfully at 01:50 am. 09/04/08. }
{ Tested program successfully. 09/08/08 early morning. v0.10. }

{ 10/08/08: moved old comments to LRS-ARCH.TXT file. }


